#include <cassert>
#include "null.hpp"

struct A { int i; };
static int x;

static bool f (int *ip)      { return bool (ip); }

static bool g (int A::* pmi) { return bool (pmi); }

static bool h (int *ip)      { return bool (ip); }
static bool h (int A::* pmi) { return bool (pmi); }

static bool m (int i)        { return bool (i); }

int
main (int argc, char *argv[])
{
  assert (f (&x));
  assert (! f (null));

  assert (g (&A::i));
  assert (! g (null_ptr_to_member));

  assert (h (&x));
  assert (h (&A::i));
  //h (null);

  assert (m (1));
  assert (! m (0));
  //assert (m (null));

  return 0;
}
